package edu.sdsu.cs.util.tests;

import static org.junit.Assert.*;

import org.junit.Test;

import edu.sdsu.cs.util.Alphabet;
import edu.sdsu.cs.util.TrieInnerNode;
import edu.sdsu.cs.util.TrieNodeIterator;

public class TrieNodeIteratorTests extends TrieInnerNode {

	@Test
	public void testSmallTrie() {
		Alphabet small = new Alphabet("abc");
		TrieInnerNode root = new TrieInnerNode(small,null,'c');
		TrieNodeIterator iterator = new TrieNodeIterator(root);
		assertTrue(iterator.hasNext());
		assertEquals(root, iterator.next());
		assertTrue(iterator.hasNext());
		assertTrue(iterator.next().isNull());
		assertTrue(iterator.hasNext());
		assertTrue(iterator.next().isNull());
		assertTrue(iterator.hasNext());
		assertTrue(iterator.next().isNull());
		assertFalse(iterator.hasNext());
	}
	
	public void testTwoLevelTrie() {
//		Alphabet small = new Alphabet("abc");
//		InnerNode root = new InnerNode(small,null,'c');
//		InnerNode a = new InnerNode(small,null,'a');
//		InnerNode b = new InnerNode(small,null,'b');
//		root.replaceNodeWith(a);
//		TrieNodeIterator iterator = new TrieNodeIterator(root);
//		assertTrue(iterator.hasNext());
//		assertEquals(root, iterator.next());
//		assertTrue(iterator.hasNext());
//		assertTrue(iterator.next().isNull());
//		assertTrue(iterator.hasNext());
//		assertTrue(iterator.next().isNull());
//		assertTrue(iterator.hasNext());
//		assertTrue(iterator.next().isNull());
//		assertFalse(iterator.hasNext());
	}

}
