package edu.sdsu.cs.util.tests;

import static org.junit.Assert.*;

import org.junit.Test;

import edu.sdsu.cs.util.Alphabet;
import edu.sdsu.cs.util.TrieInnerNode;
import edu.sdsu.cs.util.IteratorPathMarker;
import edu.sdsu.cs.util.WordParameter;

public class PathMarkerTests {

	@Test
	public void test() {
		Alphabet small = new Alphabet("abc");
		TrieInnerNode testData = new TrieInnerNode(small,null,'c');
		testData.add(new WordParameter("c"));	
		IteratorPathMarker marker = new IteratorPathMarker(testData);
		assertTrue(marker.hasNext());
		assertTrue(marker.next().isNull());
		assertTrue(marker.hasNext());
		assertTrue(marker.next().isNull());
		assertTrue(marker.hasNext());
		assertFalse(marker.next().isNull());
		assertFalse(marker.hasNext());
	}

}
